/* Constant variables */
const int BUTTON1 = 3;
const int BUTTON2 = 4;
const int BUTTON3 = 5;
const int BUTTON4 = 6;

const int LED1 = 9;
const int LED2 = 10;
const int LED3 = 11;
const int LED4 = 12;

const int BUZZER = 8;
const int TOUCH = 2;

const int DIF1 = 3;
const int DIF2 = 6;
const int DIF3 = 9;

const int num_levels = 15;

const int delay_min = 200;
const int delay_max = 1000;
const int buzzer_frec = 500;

const int nr_buttons = 4;
const int nr_leds = 4;

const int limit_increase = 25;

void setup() {
  /* Input - push buttons */
  pinMode(BUTTON1, INPUT_PULLUP);
  pinMode(BUTTON2, INPUT_PULLUP);
  pinMode(BUTTON3, INPUT_PULLUP);
  pinMode(BUTTON4, INPUT_PULLUP);
  /* Output - led */
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  /* Output - buzzer */
  pinMode(BUZZER, OUTPUT);
  pinMode(TOUCH, INPUT);
  
  randomSeed(analogRead(0));
}
/* function which turn on and off all leds */
void turn_on_leds() {
    digitalWrite(LED1, HIGH);
    digitalWrite(LED2, HIGH);
    digitalWrite(LED3, HIGH);
    digitalWrite(LED4, HIGH);
    delay(delay_min);
    digitalWrite(LED1, LOW);
    digitalWrite(LED2, LOW);
    digitalWrite(LED3, LOW);
    digitalWrite(LED4, LOW);
    delay(delay_min);
}


int random_num = 0; 
int pressed = 1;
int correct = 0;
int start_game = 0;
int show_seq = 1;
int level = 1;

int limit = 50;


int button_seq[num_levels]; /* saves the correct buttons sequence */
int pressed_buttons[num_levels]; /* saves the pin of pressed buttons */
int is_Pressed[] = {0, 0, 0, 0}; /* 1 if button is pressed */
int rand_num[num_levels];
int counter = 0;

void loop() {
  if (start_game == 0) {
    start_game = digitalRead(TOUCH);
  }
  if (start_game == 1) {
    int i, j = 0;
    delay(delay_max - limit);
   
    if (show_seq == 1) {
      random_num = random(LED1, LED4 + 1);
      rand_num[counter] = random_num;
       /* saves the button connected with the led that turned on */
      button_seq[counter] = random_num - DIF2;
      for(i = 0; i < level; i++) {
        /* turn on a random led */
        digitalWrite(rand_num[i], HIGH);
        delay(delay_max/2 - limit);
        digitalWrite(rand_num[i], LOW);
        delay(delay_min); 
      }
      show_seq = 0;
      correct = 0;
    }

    while (j < level) {
      delay(delay_max + delay_min);
      /* wait for a player to press a button */
      while (pressed == 1) {
        for (i = 0; i < nr_buttons; i++){
          is_Pressed[i] = digitalRead(i + DIF1);
          if(is_Pressed[i] == 0) {
            pressed = 0;
          }
        }
      }
      for (i = 0; i < nr_leds; i++) {
        if (is_Pressed[i] == LOW) {
          /* turn on a led which button was pressed */
          digitalWrite(i + DIF3, HIGH);
          delay(delay_min);
          digitalWrite(i + DIF3, LOW);
          is_Pressed[i] = HIGH; 
          pressed = 1;
          pressed_buttons[j] = i + DIF1;    
        }
      }
      /* corect button was pressed */
      if(pressed_buttons[j] == button_seq[j]) {
        j++;
        correct++;
      }
      /* the player pressed wrong button  */
      else {
        correct = -1;
        j = level;
      } 
    }

  if(correct == -1) {
    delay(delay_min);
    /* turn on the buzzer, and restart the flags, so the game starts again */
    tone(BUZZER, buzzer_frec);
    delay(delay_max / 2);
    noTone(BUZZER);
    show_seq = 1;
    level = 1;
    limit = 50;
    start_game = 0;
    counter = 0;
  }

  if(correct == level) {
    /* the player has won current level, increse the level variable, 
     * and decrease the time of the led turned on with limit variable */
    turn_on_leds();
    show_seq = 1;
    level++;
    limit += limit_increase;
    counter++;
  }
  if (level - 1 == num_levels){
    /* the game is won */
    for(i = 0; i < nr_leds; i++) {
      tone(BUZZER, buzzer_frec);
      turn_on_leds();
    }
     noTone(BUZZER);
     /* start the game again */
    show_seq = 1;
    level = 1;
    start_game = 0;
    counter = 0;
  }
  }
}
